package com.fp.persistence.pgeneral.gene;

import com.fp.dto.hb.Cache;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENECATALOGDETAILTEST*/
@Entity(name="TgeneCatalogDetailTest")
@Table(name="TGENECATALOGDETAILTEST")
public class TgeneCatalogDetailTest extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable,Cache{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneCatalogDetailTest
*/
@EmbeddedId
private TgeneCatalogDetailTestKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="DESCRIPTION", nullable=false)

/**
* Descripcion del catalogo 
*/
private String description;

@Column(name="LEGALCODE", nullable=true)

/**
* Codigo del organismo de control
*/
private String legalcode;

@Column(name="IDALFRESCO", nullable=true)

/**
* null
*/
private String idalfresco;

/**Contructor por defecto*/
public TgeneCatalogDetailTest(){
}
/**Contructor de TgeneCatalogDetailTest
@param pPk Clave Primaria del entity
@param pDescription Descripcion del catalogo 
*/
public TgeneCatalogDetailTest(TgeneCatalogDetailTestKey pPk,String pDescription){
 this();
 pk=pPk;
 description=pDescription;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneCatalogDetailTest
*/
public static TgeneCatalogDetailTest find(EntityManager pEntityManager,TgeneCatalogDetailTestKey pKey) throws Exception{
    TgeneCatalogDetailTest obj = pEntityManager.find(TgeneCatalogDetailTest.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneCatalogDetailTest
@return El objeto que referencia a la Clave primaria de TgeneCatalogDetailTest
*/
public TgeneCatalogDetailTestKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneCatalogDetailTest
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneCatalogDetailTest
*/
public void setPk(TgeneCatalogDetailTestKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de legalcode
@return valor de legalcode*/
public String getLegalcode(){
  return legalcode;
}
/**Fija el valor de legalcode
@param pLegalcode nuevo Valor de legalcode*/
public void setLegalcode(String pLegalcode){
  legalcode=pLegalcode;
}

/**Obtiene el valor de idalfresco
@return valor de idalfresco*/
public String getIdalfresco(){
  return idalfresco;
}
/**Fija el valor de idalfresco
@param pIdalfresco nuevo Valor de idalfresco*/
public void setIdalfresco(String pIdalfresco){
  idalfresco=pIdalfresco;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneCatalogDetailTest))return false;
    TgeneCatalogDetailTest that = (TgeneCatalogDetailTest) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TgeneCatalogDetailTest
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TgeneCatalogDetailTest
*/
public Object createInstance(){
 TgeneCatalogDetailTest instance=new TgeneCatalogDetailTest();	
 instance.setPk(new TgeneCatalogDetailTestKey());
 return instance;
}
/**Clona la entidad TgeneCatalogDetailTest
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneCatalogDetailTest p=(TgeneCatalogDetailTest)this.clone();
  p.setPk((TgeneCatalogDetailTestKey)this.pk.cloneMe());
  return p;
}
}
